#TEMPLATE(SimpleDisplayInfo,'Get Display Information -Global Simplate'),FAMILY('ABC')
#!------------------------------------------------
#!Get Display Information
#!From Arnor Baldvinsson's Icetips, Tip#3 at http://www.icetips.com
#!------------------------------------------------
#!
#EXTENSION(DisplayInfo,'Get Display Information'),APPLICATION
#DISPLAY('Simplates By Mike Pasley - DisplayInfo Code Simplate ')
#DISPLAY('Get Display Information')
#DISPLAY(' ')
#DISPLAY(' ')
#DISPLAY('')
!DisplayInfo Simplate -Get Display Information
#AT(%GlobalMap),PRIORITY(4000)
GetWindowVersion,STRING
GetScreenResolution,STRING
GetNumberOfColors,LONG
#ENDAT
#GLOBALDATA
SCREEN:WIDTH    SHORT
SCREEN:HEIGHT   SHORT
WinVer  STRING(20)         ! Get Windows version number
NColors LONG        ! Get Windows number of colors
ScrRes  STRING(100)
CurrentHandle LONG
#ENDGLOBALDATA
#AT(%GlobalData)
!Constants you can use with GetSystemMetrics:
sm_CXScreen      EQUATE(0)   !  Screen width
sm_CYScreen      EQUATE(1)   !  Screen height
sm_CXVScroll     EQUATE(2)   !  Vertical scroll bar arrow width
sm_CYHScroll     EQUATE(3)   !  Horizontal scroll bar arrow width
sm_CYCaption     EQUATE(4)   !  Height of caption
sm_CXBorder      EQUATE(5)   !  Frame width of non-sizeable window
sm_CYBorder      EQUATE(6)   !  Frame height of non-sizeable window
sm_CXDlgFrame    EQUATE(7)   !  Dialog window frame width
sm_CYDlgFrame    EQUATE(8)   !  Dialog window frame height
sm_CYVThumb      EQUATE(9)   !  Thumb width of vertical scroll bar
sm_CXHThumb      EQUATE(10)  !  Thumb width of horizontal scroll bar
sm_CXIcon        EQUATE(11)  !  Icon width
sm_CYIcon        EQUATE(12)  !  Icon height
sm_CXCursor      EQUATE(13)  !  Cursor width
sm_CYCursor      EQUATE(14)  !  Cursor height
sm_CYMenu        EQUATE(15)  !  Menu height)  !  single line menu
sm_CXFullScreen  EQUATE(16)  !  Width of a maximized window's client area
sm_CYFullScreen  EQUATE(17)  !  Height of a maximized window's client area
sm_MousePresent  EQUATE(19)  !  0 if no mouse present
sm_CYVScroll     EQUATE(20)  !  Vertical scroll bar arrow height
sm_CXHScroll     EQUATE(21)  !  Horizontal scroll bar arrow height
sm_Debug         EQUATE(22)  !  0 if Windows version is not debugging version
sm_SwapButton    EQUATE(23)  !  0 if mouse buttons are not swapped
sm_CXMin         EQUATE(28)  !  Minimum width of a window
sm_CYMin         EQUATE(29)  !  Minimum height of a window
sm_CXSize        EQUATE(30)  !  Width of title bar bitmap
sm_CYSize        EQUATE(31)  !  Height of title bar bitmap
sm_CXFrame       EQUATE(32)  !  Width of the frame on a sizable window
sm_CYFrame       EQUATE(33)  !  Height of the frame on a sizable window

!Constants you can use with GetDeviceCaps:
DriverVersion EQUATE(0)   !  Device driver version                    
Technology    EQUATE(2)   !  Device classification                    
HorzSize      EQUATE(4)   !  Horizontal size in millimeters           
VertSize      EQUATE(6)   !  Vertical size in millimeters             
HorzRes       EQUATE(8)   !  Horizontal width in pixels               
VertRes       EQUATE(10)  !  Vertical width in pixels                 
BitsPixel     EQUATE(12)  !  Number of bits per pixel                 
Planes        EQUATE(14)  !  Number of planes                         
NumBrushes    EQUATE(16)  !  Number of brushes the device has         
NumPens       EQUATE(18)  !  Number of pens the device has            
NumMarkers    EQUATE(20)  !  Number of markers the device has         
NumFonts      EQUATE(22)  !  Number of fonts the device has           
NumColors     EQUATE(24)  !  Number of colors the device supports     
PDeviceSize   EQUATE(26)  !  Size required for device descriptor      
CurveCaps     EQUATE(28)  !  Curve capabilities                       
LineCaps      EQUATE(30)  !  Line capabilities                        
PolygonalCaps EQUATE(32)  !  Polygonal capabilities                   
TextCaps      EQUATE(34)  !  Text capabilities                        
ClipCaps      EQUATE(36)  !  Clipping capabilities                    
RasterCaps    EQUATE(38)  !  Bitblt capabilities                      
AspectX       EQUATE(40)  !  Length of the X leg                      
AspectY       EQUATE(42)  !  Length of the Y leg                      
AspectXY      EQUATE(44)  !  Length of the hypotenuse                 
LogPixelsX    EQUATE(88)  !  Logical pixels/inch in X                 
LogPixelsY    EQUATE(90)  !  Logical pixels/inch in Y                 
SizePalette   EQUATE(104) !  Number of entries in physical palette    
NumReserved   EQUATE(106) !  Number of reserved entries in palette    
ColorRes      EQUATE(108) !  Actual color resolution
#ENDAT

#AT(%GlobalMap),PRIORITY(4000)
!DisplayInfo Simplate -Get Display Information
MODULE('WINDOWS.LIB')
  GetSystemMetrics(SHORT),SHORT,RAW,PASCAL          ! Gets info on devices
  GetVersion,USHORT,RAW,PASCAL                     ! Gets version info
  GetDeviceCaps(USHORT,SHORT),SHORT,RAW,PASCAL      ! Gets device info
  GetDC(LONG),USHORT,RAW,PASCAL      ! Gets device info
END
#ENDAT
#AT(%ProgramProcedures)
!---------------------------------------------GetScreenResolution
GetScreenResolution     Procedure

 CODE
 SCREEN:WIDTH  = GetSystemMetrics(0)
 SCREEN:HEIGHT = GetSystemMetrics(1)
 RETURN(CLIP(SCREEN:WIDTH) & '' & CLIP(SCREEN:HEIGHT))

!---------------------------------------------GetWindowVersion
GetWindowVersion        Procedure
WV        USHORT
HighBytes USHORT
LowBytes  USHORT

  CODE
  WV = GetVersion()
  HighBytes = BSHIFT(WV,-8)
  WV = BSHIFT(WV,8)
  LowBytes = BSHIFT(WV,-8)
  RETURN(CLIP(LowBytes) & '.' & CLIP(HighBytes+1))

!---------------------------------------------GetNumberofColors
GetNumberofColors       Procedure
NOC    LONG        ! NumberOfColors
DC     USHORT      ! Device Context number - retrieved with GetDC API call

  CODE
  DC   = GetDc(CurrentHandle)
  NOC  = GetDeviceCaps(DC,12)    ! 24 = Color resolution in bits per pixel

  Return(NOC)
!-------------------
#ENDAT

